%define TRACEEVENT_DIR /usr/lib64/%{name}-traceevent
%define PLUGINS_DIR %{TRACEEVENT_DIR}/plugins
%define has_btf %(test -f /sys/kernel/btf/vmlinux && echo 1 || echo 0)
%undefine _disable_source_fetch
%define debug_package %{nil}

Name:           perf-prof
Version:        1.4.2
Release:        1%{?dist}
License:        GPL2
Group:          Unspecified
Summary:        Profiling based on perf_event
Distribution:   OpenCloudOS
Vendor:         Tencent
URL:            https://github.com/OpenCloudOS
BuildArch:      x86_64
ExclusiveArch:  x86_64

Requires:       elfutils-libelf,glibc,xz-libs
BuildRequires:  elfutils-libelf-devel,xz-devel,gcc,clang

%if %{has_btf}
BuildRequires:  llvm,bpftool
%endif

Source0:        %{name}-%{version}.tar.gz

%description
Profiling based on perf_event: split-lock, irq-off, profile,
task-state, watchdog, kmemleak, kvm-exit, mpdelay.

%prep
%setup -q

%build
if [ -f /sys/kernel/btf/vmlinux ]; then
    make CONFIG_LIBBPF=y
else
    make
fi
strip -g %{name}

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/usr/bin/ %{buildroot}%{PLUGINS_DIR} %{buildroot}/etc/bash_completion.d/
install -m 0755 -o root -g root %{name} %{buildroot}/usr/bin/
install -m 0755 -o root -g root flamegraph.pl %{buildroot}/usr/bin/
install -m 0755 -o root -g root trace2heatmap.pl %{buildroot}/usr/bin/
install -m 0755 -o root -g root lib/traceevent/plugins/*.so %{buildroot}%{PLUGINS_DIR}
cp packages/%{name} %{buildroot}/etc/bash_completion.d/

%files
/usr/bin/%{name}
/usr/bin/flamegraph.pl
/usr/bin/trace2heatmap.pl
%{TRACEEVENT_DIR}
%{PLUGINS_DIR}
/etc/bash_completion.d/%{name}


%changelog
* Fri Feb 14 2025 Joshua Hu <joshuahu@tencent.com> - 1.4.2-1
- [Type] other
- [DESC] fix make error & add support for ebpf

* Thu Feb 13 2025 Joshua Hu <joshuahu@tencent.com> - 1.4.1-1
- init in ocs

* Sun Feb  6 2022 Duanery <corcpp@foxmail.com>
- Supports multiple types of stack processing and flame graph.

* Sun Jan 23 2022 Builder <corcpp@foxmail.com>
- first version
- split-lock, irq-off, profile, task-state, watchdog, kmemleak, kvm-exit, mpdelay.
- Kernel stack support, user stack support
